#!/usr/bin/perl
use locale;
use English;
use Getopt::Std;
use Encode::Encoding;
use Encode::CN;
use Encode::KR;
use Encode::TW;
use Encode::JP;
use Unicode::String qw(utf8);

my $VERSION="1.0";
my $CMD="minigrepmultilingue";
my $MODIFIED="19/10/2007";
my $HELP="
___________________________________________________________________________

$CMD $VERSION (c) Serge Fleury SYLED/CLA2T PLURITAL $MODIFIED
___________________________________________________________________________

OBJECTIF : un mini-grep-multilingue 

SYNTAXE :   $CMD [options] <fichier-codage> <fichier-a-filtrer> <fichier-avec-motif> 

OPTIONS :
  -h        imprime le mode d'emploi de ce programme

EXEMPLES:
    perl mini-grep-multilingue.pl \"UTF-8\" RU_Convention_UTF8.txt motif.txt

___________________________________________________________________________


";
###########################################################################
# parse command line
###########################################################################
getopts('hdt');
if (defined($opt_h)) {
  print STDERR "$HELP";
  exit(1);
}
#----------------------------------------------------------------------------
if ((!($ARGV[0])) || (!($ARGV[1])) || (!($ARGV[2])))  {
    print "___________________________________________________________________________\n\nERREUR : Le programme necessite 3 arguments : \n 1. un encodage,\n 2. un fichier a filtrer,\n 3. un fichier contenant le motif  filtrer \n\n";
    print "Exemple de lancement : \n";
    print "___________________________________________________________________________\n\n";
    print "perl mini-grep-multilingue.pl \"UTF-8\" RU_Convention_UTF8.txt motif.txt \n\n";
    exit;
}
###########################################################################
# A. Lecture des arguments du programme 
my $tmpcodage=$ARGV[0];
chomp($tmpcodge);
my $filein=$ARGV[1];
print "Fichier en entree : $filein \n";
my $filewithforme=$ARGV[2];
my $fileout="resultat-extraction.html";
###########################################################################
print "extraction du motif...\n";
# B. le fichier contenant la forme  extraire
open(FILE0,"<:encoding($tmpcodage)",$filewithforme) or die "Pb sur l'ouverture du fichier $filewithforme !!! ";
my $formein=<FILE0>;
chomp($formein);
$formein=~/MOTIF=(\w+)$/;
my $forme=$1;
utf8($forme);
#print "Forme a rechercher : $forme \n";
close(FILE0);
###########################################################################
print "extraction de la forme et ecriture du resultat dans $fileout \n";
# C. Parcours du fichier et extraction du motif
open(FILEIN,"<:encoding($tmpcodage)",$filein) or  die "Pb sur l'ouverture du fichier $filein !!! ";
open(FILEOUT,">:encoding(UTF-8)",$fileout) or  die "Pb sur l'ouverture du fichier $fileout !!! ";

print FILEOUT "<html>\n<head>\n<title>mini-egrep multi-encodage pour le projet : la vie des mots sur le web</title>\n";
print FILEOUT "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf8\" />\n";
print FILEOUT "<body bgcolor=\"white\">\n";
 
print FILEOUT "<p align=\"justify\"><font color=\"blue\"><b>Encodage utilis (INPUT) :</b></font> $tmpcodage </p>\n";
print FILEOUT "<p align=\"justify\"><font color=\"blue\"><b>Forme recherche :</b></font> <font color=\"red\">$forme</font> </p>\n";
print FILEOUT "<font color=\"blue\">_________________________________________________________________________________________________ </font>\n";
my $i=1;
print FILEOUT "<blockquote>\n";
print FILEOUT "<ul>\n";
while(my $ligne=<FILEIN>)  {
#    print "recherche sur ligne : $i \n";
    utf8($ligne);
    if ($ligne=~/($forme)/) { 
	$ligne=~s/($forme)/<font color=\"red\"><b>$1<\/b><\/font>/g;
	print FILEOUT "<li><font color=\"blue\"><b>Ligne n$i</b></font> : $ligne </li>"; 
    }
    $i++;
}
print FILEOUT "</ul>\n";
print FILEOUT "</blockquote>\n";
print FILEOUT "</html></body>";
###########################################################################
close(FILEIN);
close(FILEOUT);
###########################################################################
